<?php

namespace App\Filament\Exports;

use App\Models\CharacteristicValue;
use App\Models\ProductCharacteristicsMaster;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class CharacteristicValueExporter extends Exporter
{
    protected static ?string $model = CharacteristicValue::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;

        return [
            ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.code')
                ->label('PLANT CODE'),
            ExportColumn::make('line.name')
                ->label('LINE NAME'),
            ExportColumn::make('item.code')
                ->label('ITEM CODE'),
            ExportColumn::make('item.description')
                ->label('DESCRIPTION'),
            ExportColumn::make('machine.work_center')
                ->label('WORK CENTER'),
            ExportColumn::make('process_order')
                ->label('PROCESS ORDER'),
            ExportColumn::make('coil_number')
                ->label('COIL NUMBER'),
            ExportColumn::make('status')
                ->label('STATUS'),
            ExportColumn::make('spec_value')
                ->label('Spec. Value')
                ->formatStateUsing(function ($record) {

                    $specVal = ProductCharacteristicsMaster::where('plant_id', $record->plant_id)
                        ->where('item_id', $record->item_id)
                        ->where('line_id', $record->line_id)
                        ->where('machine_id', $record->machine_id)
                        ->first();

                    return $specVal?->lower . ' - ' . $specVal?->upper;
                }),
            ExportColumn::make('observed_value')
                ->label('OBSERVED VALUE'),
            ExportColumn::make('created_at')
                ->label('CREATED AT'),
            ExportColumn::make('created_by')
                ->label('CREATED BY'),
            ExportColumn::make('updated_at')
                ->label('UPDATED AT'),
            ExportColumn::make('updated_by')
                ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
                ->enabledByDefault(false)
                ->label('DELETED AT'),

        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your characteristic value export has completed and '.number_format($export->successful_rows).' '.str('row')->plural($export->successful_rows).' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' '.number_format($failedRowsCount).' '.str('row')->plural($failedRowsCount).' failed to export.';
        }

        return $body;
    }
}
